/*	DIP.cpp
*
*	Game Timer DIP switches
*
*	Written by Cathy Saxton
*	robotics@idleloop.com
*/

#include <avr/io.h>
#include "main.h"
#include "DIP.h"

ulong DIP::MsTimer()
{
	ulong ms;

	/* low 5 bits of PINC specify 'count' of units; since switches are 1 when open
	   and 0 when closed, invert to get the value we need; convert from sec to ms */
	ms = 1000 * (ushort)(~PINC & 0x1f);
	if (ms == 0)	// all sw off -- use 32
		ms = 32000;
	if (!(PINC & 0x20))	// right bit of unit indicates 1 or 5
		ms *= 5;
	if (!(PIND & 0x01))	// left bit of unit indicates sec or min
		ms *= 60;

	return ms;
}
